#include <iostream>
#include <queue> // Priority_queue
#include <cmath> // Infinito (INFINITY)
#include "graph.h"

using namespace std;

struct queue_node{
  int vert;
  int dist;
};

bool operator <(queue_node n1, queue_node n2){
  return n1.dist>n2.dist;
}

int posicion_dist(int i, int j, int width){
  return i*width+j;
}

graph::graph(int t){
  num_vertices = t;
  distancias = 0;
  list_ad = new edge*[num_vertices];
	
  for (int i=0; i<num_vertices; ++i)
    list_ad[i] = 0;

  int talla=num_vertices*num_vertices;
  distancias=new double[talla];
  for(int i=0;i<num_vertices;++i)
    for(int j=0;j<num_vertices;++j){
      int pos=posicion_dist(i, j, num_vertices);
      distancias[pos]=0;
    }
}

graph::~graph(){
  for (int i=0; i<num_vertices; ++i){
    while (list_ad[i]) {
      edge *aux=list_ad[i];
      list_ad[i] = list_ad[i]->next;
      delete aux;   
    }
  }
  delete[] list_ad;
  delete[] distancias;
}

void graph::imprimir(){
  int i,j;
  char *buffer=new char[100000000];
  int cont=0;
  char auxiliar[7];
  int pos=0;
  for (i=0;i<num_vertices; ++i){
    for(j=0;j<num_vertices;++j){
      pos=posicion_dist(i, j, num_vertices);
      double num=distancias[pos];
      int aux;
      if(num==INFINITY){
	buffer[cont]='i';
	++cont;
	buffer[cont]='n';
	++cont;
	buffer[cont]='f';
	++cont;
	buffer[cont]=' ';
	++cont;
      }
      else{
	int numero=(int)num;
	int cuenta=0;
	while(numero>=10){
	  aux=numero%10;
	  auxiliar[cuenta]=aux+'0';
	  numero/=10;
	  ++cuenta;
	}
	buffer[cont]=numero+'0';
	++cont;
	for(int q=cuenta-1;q>=0;--q){
	  buffer[cont]=auxiliar[q];
	  ++cont;
	}
	buffer[cont]=' ';
	++cont;
      }	
    }
    buffer[cont]='\n';
    ++cont;
  }
  cout.write(buffer, cont);
  delete [] buffer;
}

void graph::insertar(int u, int v, int w){
  list_ad[u] = new edge(v, w, list_ad[u]);
}

void graph::dijkstra(int s) {
  priority_queue<queue_node> cola_p;

  for (int i = 0; i < num_vertices; ++i) {
    int pos=posicion_dist(s, i, num_vertices); 
    distancias[pos] = INFINITY;
  }

  int pos=posicion_dist(s, s, num_vertices);
  distancias[pos] = 0;

  queue_node aux_node_0;
  aux_node_0.vert=s;
  aux_node_0.dist=0;
  cola_p.push(aux_node_0);

  while(!cola_p.empty()){
    queue_node u=(cola_p.top());
    cola_p.pop();
    for(edge *v=list_ad[u.vert]; v!=0;v=v->next){
      int w=v->vert_dest;
      int alt=u.dist+v->valor;
      int pos=posicion_dist(s, w, num_vertices);
      if(alt < distancias[pos]){
	distancias[pos]=alt;
	queue_node aux_node;
	aux_node.dist=alt;
	aux_node.vert=w;
	cola_p.push(aux_node);
      }
    }
  }
}
